;###############################################################################
;
;	PIC FT245AM TEST
;
;		Preprocess by pic80ppc and Assemble by pa-3.0.5s

;-------------------------------------------------------------------------------
;
;	إå
;
		include		my16f648.h
		.16f84				; PIC16F84()

;-------------------------------------------------------------------------------
;
;	ϥݡ
;
MYTRISA		equ	00100000b		; (0:, 1:())
LED		equ	    3
RD		equ	   4
RXF		equ	  5
ANA0		equ	 6
ANA1		equ	7

MYTRISB		equ	11111111b		; (0:, 1:())

;-------------------------------------------------------------------------------
;
;	EEPROM
;
		eeorg	0			; EEDATA

;-------------------------------------------------------------------------------
;
;	ꥻ
;
		org	20h			; ޥå

PWMONSPAN	ds	1
PWMOFFSPAN	ds	1

waitCntS	ds	1			; Ԥѥ
waitCntM	ds	1
waitCntL	ds	1

;-------------------------------------------------------------------------------
;
;	ץॻ
;
		org	00h			; ꥻåȥ٥
		JP	start

;-------------------------------------------------------------------------------
;
;	߽
;
		org	04h			; ߥ٥
		JP	start

;-------------------------------------------------------------------------------
;
;	å׽
;
start
		RES	RP1, (STATUS)
		RES	RP0, (STATUS)		; Х0

		CLR	(PORTA)			; ݡAꥢ
		CLR	(PORTB)			; ݡBꥢ

		LD	A, 00000111b
		LD	(CMCON), A		; ѥ졼OFF

		SET	RP0, (STATUS)		; Х1

		LD	A, MYTRISA
		LD	(TRISA), A		; ݡA
		LD	A, MYTRISB
		LD	(TRISB), A		; ݡB

		RES	RP0, (STATUS)		; Х0
timerSet
		CLR	(WDT)			; åɥåޡץꥹ饯ꥢ
		CLR	(TMR0)			; ޥꥢ

		SET	RP0, (STATUS)		; Х1

		LD	A, 11111111b		; :11111111b
		LD	(OPTION), A		; 7:GPIOץ륢å(0:Ѥ)
						; 6:GP2ߥݡѲ(0:Ω)
						; 5:TMR0åӥå(0:)
						; 4:GP2ѲTMR0ûߥ(0:Ω)
						; 3:ץꥹƥӥå(0:TMR0)
						; 2~0ץꥹ졼ӥå(111:1/128)

		RES	RP0, (STATUS)		; Х0
intStart
		LD	A, 00000000b		; :00000000b
		LD	(INTCON), A		; 7:Хߥ֥͡
						; 5:TMR0Сեߥ֥͡
						; 4:GP2ݡѲߥ֥͡
						; 3:ݡѲߥ֥͡

;###############################################################################
;
;	ᥤ
;
		LD	A, 080H
		CALL	recv1
main
		LD	A, 11110111b		; LED
		AND	(PORTA), A
		LD	A, 11000000b		; PWM ON
		OR	(PORTA), A
		LD	A, (PWMONSPAN)
		CALL	PWMWAIT

		CALL	recv			; ǡɤ߹

		LD	A, 00001000b		; LED
		OR	(PORTA), A
		LD	A, 00111111b		; PWM OFF
		AND	(PORTA), A
		LD	A, (PWMOFFSPAN)
		CALL	PWMWAIT

		JP	main

;-------------------------------------------------------------------------------
;
;	PCΥǡ
;
recv
		BIT	RXF, (PORTA)		; RXFLOWǧ
		RET	NZ

		RES	RD, (PORTA)		; ɤ߹߳
		NOP
		LD	A, (PORTB)		; ǡɤ
recv1
		LD	(PWMONSPAN), A
		LD	(PWMOFFSPAN), A
		INC	(PWMONSPAN)		; PWMON (x + 1)
		DEC	(PWMOFFSPAN)
		CPL	(PWMOFFSPAN)		; PWMOFF !(x - 1)

		SET	RD, (PORTA)		; ɤ߹߽λ

		RET

;-------------------------------------------------------------------------------
;
;	20üLEDǽ(å®ٷ¬)
;
getClock
		SET	LED, (PORTA)

		LD	A, 10			; 100ꤹȡ
		CALL	WAITnx01sm25us		; 2Ԥ 100 x 100ms - 25us 񤹤
		LD	A, 6			; 10ꤹȡ
		CALL	WAITnx3p5us		; 2Ԥ 6 x 3 + 5 = 23us 

		RES	LED, (PORTA)

		LD	A, 10			; 100ꤹȡ
		CALL	WAITnx01sm25us		; 2Ԥ 100 x 100ms - 25us 񤹤
		LD	A, 6			; 10ꤹȡ
		CALL	WAITnx3p5us		; 2Ԥ 6 x 3 + 5 = 23us 

		JP	getClock

;-------------------------------------------------------------------------------
;
;	Ԥ()
;
;		LD	A, 10			; 10ꤹȡ
;		CALL	WAITnx3p5us		; 2Ԥ 10 x 3 + 5 = 35us 
;
WAITnx3p5us
		LD	(waitCntS), A
WAITnx3p5us1
		DJNZ	(waitCntS), WAITnx3p5us1
		RET

;-------------------------------------------------------------------------------
;
;	Ԥ(PWM)
;
PWMWAIT
		LD	(waitCntM), A
PWMWAIT1	LD	A, 40
		CALL	WAITnx3p5us
		DJNZ	(waitCntM), PWMWAIT1
		RET

;-------------------------------------------------------------------------------
;
;	Ԥ()
;
;		LD	A, 200			; 0.1äߤ硢200ꤹȡ
;		CALL	WAITnx500m35us		; 2Ԥ 200 x 500 - 35 = 99.965ms 񤹤
;
WAITnx500m35us
		LD	(waitCntM), A
		JP	WAITnx500m35us2
WAITnx500m35us1	NOP
		LD	A, 12			;  12 x 3 + 5 =  41us
		CALL	WAITnx3p5us		;		λԤ
WAITnx500m35us2	LD	A, 150			; 150 x 3 + 5 = 455us
		CALL	WAITnx3p5us		;		λԤ
		DJNZ	(waitCntM), WAITnx500m35us1
		RET

;-------------------------------------------------------------------------------
;
;	Ԥ()
;
;		LD	A, 10			; 1äߤ硢10ꤹȡ
;		CALL	WAITnx01sm25us		; 2Ԥ 10 x 100ms - 25us 񤹤
;
WAITnx01sm25us
		LD	(waitCntL), A
		JP	WAITnx01sm25us2
WAITnx01sm25us1	LD	A, 9
		CALL	WAITnx3p5us
WAITnx01sm25us2	LD	A, 200
		CALL	WAITnx500m35us
		DJNZ	(waitCntL), WAITnx01sm25us1
		RET

